# (c) microelly 2015

print "Dreitafelbild Modul"

import FreeCAD,Draft

import FreeCAD,Draft
App=FreeCAD

def say(s):
		FreeCAD.Console.PrintMessage(str(s)+"\n")

import os
__dir__ = os.path.dirname(__file__)	
say(__dir__)

#---------------------------------------------------------------
def createdtb(name="DreiTafelBild"):
		obj = FreeCAD.ActiveDocument.addObject("App::DocumentObjectGroupPython",name)
		obj.addProperty("App::PropertyLink","model","3D","Objekct")
		obj.addProperty("App::PropertyLink","origin","3D","Bezug")
		obj.addProperty("App::PropertyLinkList","helpers","3D","hilfsbojecht")
		_Mydtb(obj)
		_ViewProviderMydtb(obj.ViewObject)
		FreeCAD.dtb_lock=False
		return obj


class _Mydtb(object):
# Proxy Methoden
	def __init__(self,obj):
		obj.Proxy = self
		self.Type = "_Mydtb"
		self.Object=obj

	def initialize(self):
		say("initialize ...")
		say(self)
		
	def execute(self,obj):
		say("execute " +str(obj))
		if hasattr(FreeCAD,'dtb_lock'):
			if FreeCAD.dtb_lock:
				return
		if not obj.helpers:
			return
		FreeCAD.dtb_lock=True
		say("anpassung---------------------------------------------")
		say(obj.model.Placement)
		if obj.origin:
			say(obj.origin.Placement.Base)
		# update
		p=obj.origin
		px=p.X
		py=p.Y
		pz=p.Z
	 
		[lx,ly,lz,an,an2,an3,anh,an2h,an3h]=obj.helpers
		
		an.Placement.Base=App.Vector(0,py-pz,0)
		an3.Placement.Base=App.Vector(px+py,py-pz,0)
		anh.Placement.Base=App.Vector(0,py-pz,0)
		an3h.Placement.Base=App.Vector(px+py,py-pz,0)
		 
		lx.Start,lx.End=FreeCAD.Vector(px,py,0),FreeCAD.Vector(an.Shape.BoundBox.XMin-10,py,0.0)
		say
		ly.Start,ly.End=FreeCAD.Vector(px,py,0),FreeCAD.Vector(px,an3.Shape.BoundBox.YMax+10,0.0)
		lz.Start,lz.End=FreeCAD.Vector(px,py,0),FreeCAD.Vector(an3.Shape.BoundBox.XMax+10,(px+py)-an3.Shape.BoundBox.XMax-10,0.0)
		App.activeDocument().recompute()
		say("anpassung----------------------------------------ENDE-----")
		FreeCAD.dtb_lock=False
		say(FreeCAD.dtb_lock)
		say("ex done")
		pass

	def onChanged(self,obj,prop):
		say("onChanged OBJECT " + str(self))
		say(obj)
		say(prop)
		val=obj.getPropertyByName(prop)
		say(val)
		FreeCAD.mytoc=[self,obj,prop]
		if prop=="radiusOut":
			rin=obj.radiusIn
			self.changedRadiusOut(val,rin)
		return
			
			
	def onBeforeChange(self,obj,prop):
		say("on Before Changed OBJECT " )
		# say(arg)
		say(obj)
		say(prop)
		say(obj.getPropertyByName(prop))
		val=obj.getPropertyByName(prop)
		return


	def attach(self,vobj):
		self.Object = vobj.Object
		say("attach OBJECT")
		return	
	
	def claimChildren(self):
		say("claim Children OBJECT")
		return self.Object.Group

	def __getstate__(self):
		say('obj getstate')
		return None
	def __setstate__(self,state):
		say('obj setstate')
		say(state)
		return None
		
	def setrAttr(self,atname,atval):
		pass

	def say(self):
			FreeCAD.tt=self
			say("say" )
			for p in self.Object.PropertiesList:
				print p," == ",getattr(self.Object,p)

	def start(self):
		# das darzustellende Objekt ..
		#obj=FreeCAD.ActiveDocument.Fusion001

		#p=App.ActiveDocument.Point
		p=self.Object.origin
		obj=self.Object.model
		
		px=p.X
		py=p.Y
		pz=p.Z

		# Ansicht Front

		anh=Draft.makeShape2DView(obj)
		anh.Projection = (0.00, -1.00, 0.00)
		anh.Placement = App.Placement(App.Vector(0,py-pz,0),App.Rotation(App.Vector(0,0,-1),90))
		anh.HiddenLines = True
		anh.ViewObject.DrawStyle = "Dashed"
		

		an=Draft.makeShape2DView(obj)
		an.Projection = (0.00, -1.00, 0.00)
		an.Placement = App.Placement(App.Vector(0,py-pz,0),App.Rotation(App.Vector(0,0,-1),90))


		# Top
		an2h=Draft.makeShape2DView(obj)
		an2h.Projection = ( 0.00, 0.00, 1.00)
		an2h.Placement = App.Placement(App.Vector(0,0,0),App.Rotation(App.Vector(0,0,1),0))
		an2h.HiddenLines = True
		an2h.ViewObject.DrawStyle = "Dashed"

		an2=Draft.makeShape2DView(obj)
		an2.Projection = ( 0.00, 0.00, 1.00)
		an2.Placement = App.Placement(App.Vector(0,0,0),App.Rotation(App.Vector(0,0,1),0))

		# Seite
		an3h=Draft.makeShape2DView(obj)
		an3h.Projection = (-1.00, 0.00, 0.00)
		an3h.Placement = App.Placement(App.Vector(px+py,py-pz,0),App.Rotation(App.Vector(0,0,-1),90))
		an3h.HiddenLines = True
		an3h.ViewObject.DrawStyle = "Dashed"


		an3=Draft.makeShape2DView(obj)
		an3.Projection = (-1.00, 0.00, 0.00)
		an3.Placement = App.Placement(App.Vector(px+py,py-pz,0),App.Rotation(App.Vector(0,0,-1),90))



		points=[FreeCAD.Vector(px,py,0),FreeCAD.Vector(an.Shape.BoundBox.XMin-10,py,0.0)]
		lx=Draft.makeWire(points,closed=False,face=False,support=None)

		points=[FreeCAD.Vector(px,py,0),FreeCAD.Vector(px,an3.Shape.BoundBox.YMax+10,0.0)]
		ly=Draft.makeWire(points,closed=False,face=False,support=None)

		print an3.Shape.BoundBox.XMax

		points=[FreeCAD.Vector(px,py,0),FreeCAD.Vector(an3.Shape.BoundBox.XMax+10,(px+py)-an3.Shape.BoundBox.XMax-10,0.0)]
		lz=Draft.makeWire(points,closed=False,face=False,support=None)

		App.activeDocument().recompute()
		 
		 
		 # updaten
		 
		px=p.X
		py=p.Y
		pz=p.Z
		 
		an.Placement.Base=App.Vector(0,py-pz,0)
		an3.Placement.Base=App.Vector(px+py,py-pz,0)
		anh.Placement.Base=App.Vector(0,py-pz,0)
		an3h.Placement.Base=App.Vector(px+py,py-pz,0)

		 
		lx.Start,lx.End=FreeCAD.Vector(px,py,0),FreeCAD.Vector(an.Shape.BoundBox.XMin-10,py,0.0)
		ly.Start,ly.End=FreeCAD.Vector(px,py,0),FreeCAD.Vector(px,an3.Shape.BoundBox.YMax+10,0.0)
		lz.Start,lz.End=FreeCAD.Vector(px,py,0),FreeCAD.Vector(an3.Shape.BoundBox.XMax+10,(px+py)-an3.Shape.BoundBox.XMax-10,0.0)
		self.Object.helpers=[lx,ly,lz,an,an2,an3,anh,an2h,an3h]
		for hs in self.Object.helpers:
			say(hs)
			self.Object.addObject(hs)
			
		App.activeDocument().recompute()

class _ViewProviderMydtb(object):
  
	def __init__(self,vobj):
		vobj.Proxy = self

	def getIcon(self):
		return __dir__ + '/drawing-orthoviews.svg'


	def attach(self,vobj):
		say("attach")
		say (vobj.Object.Label)
		self.Object = vobj.Object
		self.ViewObject = vobj
		return	
	
	def claimChildren(self):
		say("claim vo")
		say (self.Object.Label)
		return self.Object.Group

	def __getstate__(self):
		say('v getstate')
		say(self.Object.Label)
		return None

	def __setstate__(self,state):
		say('v setstate')
		say(state)
		return None
